# Update an opportunity

PUT https://api.close.com/api/v1/opportunity/{id}/
Content-Type: application/json

*status_id*

- See description for `status_id` in `POST /opportunity/` above.
- Setting the `status_id` to a status with a type of `won` will automatically set the `date_won` field if it is not already set or provided in the request. Reverting it from a `won` status to an `active` or `lost` will not automatically change `date_won`.

*date_won* (optional):

- If not set on the resource or in the request, the `date_won` will be set automatically to today's date when setting `status_id` to a status with type `won`. The `x-tz-offset` header, used to pass your timezone's UTC offset, will be taken into account.

*custom.FIELD_ID* (optional)

- See description for `custom.FIELD_ID` in `POST /opportunity/` above.
- Additionally, you can unset a single field by using `{ "custom.FIELD_ID": null }`, e.g.:
```
{ "custom.cf_v6S011I6MqcbVvB2FA5Nk8dr5MkL8sWuCiG8cUleO9c": null }
```
If you're trying to update a custom field and that custom field accepts multiple values, you can also specify `.add` or `.remove` as part of the field key to add/remove a single value to/from a list of values, e.g.:
```
{ "custom.cf_v6S011I6MqcbVvB2FA5Nk8dr5MkL8sWuCiG8cUleO9c.add": "Wednesday" }
```

Reference: https://developer.close.com/api/resources/opportunities/update

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Close API
  version: 1.0.0
paths:
  /opportunity/{id}/:
    put:
      operationId: update
      summary: Update an opportunity
      description: >-
        *status_id*


        - See description for `status_id` in `POST /opportunity/` above.

        - Setting the `status_id` to a status with a type of `won` will
        automatically set the `date_won` field if it is not already set or
        provided in the request. Reverting it from a `won` status to an `active`
        or `lost` will not automatically change `date_won`.


        *date_won* (optional):


        - If not set on the resource or in the request, the `date_won` will be
        set automatically to today's date when setting `status_id` to a status
        with type `won`. The `x-tz-offset` header, used to pass your timezone's
        UTC offset, will be taken into account.


        *custom.FIELD_ID* (optional)


        - See description for `custom.FIELD_ID` in `POST /opportunity/` above.

        - Additionally, you can unset a single field by using `{
        "custom.FIELD_ID": null }`, e.g.:

        ```

        { "custom.cf_v6S011I6MqcbVvB2FA5Nk8dr5MkL8sWuCiG8cUleO9c": null }

        ```

        If you're trying to update a custom field and that custom field accepts
        multiple values, you can also specify `.add` or `.remove` as part of the
        field key to add/remove a single value to/from a list of values, e.g.:

        ```

        { "custom.cf_v6S011I6MqcbVvB2FA5Nk8dr5MkL8sWuCiG8cUleO9c.add":
        "Wednesday" }

        ```
      tags:
        - subpackage_opportunities
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: Basic authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Opportunity'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                description: Any type
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                description: Any type
        '404':
          description: Not found
          content:
            application/json:
              schema:
                description: Any type
      requestBody:
        content:
          application/json:
            schema:
              description: Any type
servers:
  - url: https://api.close.com/api/v1
components:
  schemas:
    Attachment:
      type: object
      properties:
        content_type:
          type:
            - string
            - 'null'
        filename:
          type:
            - string
            - 'null'
        size:
          type:
            - integer
            - 'null'
        thumbnail_url:
          type:
            - string
            - 'null'
        url:
          type: string
      required:
        - content_type
        - filename
        - size
        - url
      title: Attachment
    CommentSummary:
      type: object
      properties:
        comment_count:
          type: integer
        thread_id:
          type: string
      required:
        - comment_count
        - thread_id
      title: CommentSummary
    RenderedIntegrationLink:
      type: object
      properties:
        name:
          type: string
        url:
          type: string
      required:
        - name
        - url
      title: RenderedIntegrationLink
    ContactEmail:
      type: object
      properties:
        email:
          type: string
        is_unsubscribed:
          type: boolean
        type:
          type: string
      required:
        - email
        - is_unsubscribed
        - type
      title: ContactEmail
    ContactPhone:
      type: object
      properties:
        country:
          type:
            - string
            - 'null'
        outbound_sms_blocked:
          type: boolean
        phone:
          type: string
        phone_formatted:
          type: string
        type:
          type: string
        tz_ids:
          type: array
          items:
            type: string
      required:
        - phone
        - type
      title: ContactPhone
    StalledOpportunityCommunicationIssue:
      type: string
      enum:
        - no_issue
        - cant_get_in_touch
        - no_communication_attempts
      title: StalledOpportunityCommunicationIssue
    StalledOpportunityActionTypeV1:
      type: string
      enum:
        - mark_as_lost
        - change_status
        - follow_up
        - adjust_close_date
        - ask_someone_else_to_reach_out
        - change_communication_method
      title: StalledOpportunityActionTypeV1
    ActionItem:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/StalledOpportunityActionTypeV1'
          description: >-
            The recommended next step to progress or resolve the stalled
            opportunity
        justification:
          type: string
          description: >-
            A short justification for the recommended action in the sales
            pipeline. Maximum 2 sentences.
      required:
        - action
        - justification
      title: ActionItem
    StalledOpportunityActionItems:
      type: object
      properties:
        communication_issue:
          $ref: '#/components/schemas/StalledOpportunityCommunicationIssue'
          description: >-
            The communication issue that is causing the stalled opportunity. If
            there is no issue, set to NoIssue.
        next_action:
          $ref: '#/components/schemas/ActionItem'
          description: >-
            An action item recommended to progress or resolve the stalled
            opportunity.
      required:
        - communication_issue
        - next_action
      title: StalledOpportunityActionItems
    OpportunityStatusType:
      type: string
      enum:
        - won
        - lost
        - active
      title: OpportunityStatusType
    StalledOpportunityActionTypeV2:
      type: string
      enum:
        - change_status
        - adjust_close_date
        - follow_up_email
        - follow_up_call
        - follow_up_sms
      title: StalledOpportunityActionTypeV2
    OpportunityChangeStatusActionDetails:
      type: object
      properties:
        status_id:
          type: string
      required:
        - status_id
      title: OpportunityChangeStatusActionDetails
    OpportunityFollowUpEmailActionDetails:
      type: object
      properties:
        contact_id:
          type: string
        message_draft:
          type: string
        subject_draft:
          type: string
      required:
        - contact_id
        - message_draft
        - subject_draft
      title: OpportunityFollowUpEmailActionDetails
    OpportunityFollowUpSMSActionDetails:
      type: object
      properties:
        contact_id:
          type: string
        message_draft:
          type: string
      required:
        - contact_id
        - message_draft
      title: OpportunityFollowUpSMSActionDetails
    OpportunityFollowUpCallActionDetails:
      type: object
      properties:
        call_plan:
          type: string
        contact_id:
          type: string
      required:
        - call_plan
        - contact_id
      title: OpportunityFollowUpCallActionDetails
    OpportunityAdjustCloseDateActionDetails:
      type: object
      properties:
        close_date:
          type: string
          format: date
      required:
        - close_date
      title: OpportunityAdjustCloseDateActionDetails
    OpportunitySuggestedActionDetails:
      oneOf:
        - $ref: '#/components/schemas/OpportunityChangeStatusActionDetails'
        - $ref: '#/components/schemas/OpportunityFollowUpEmailActionDetails'
        - $ref: '#/components/schemas/OpportunityFollowUpSMSActionDetails'
        - $ref: '#/components/schemas/OpportunityFollowUpCallActionDetails'
        - $ref: '#/components/schemas/OpportunityAdjustCloseDateActionDetails'
      title: OpportunitySuggestedActionDetails
    OpportunitySuggestedAction:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/StalledOpportunityActionTypeV2'
        details:
          oneOf:
            - $ref: '#/components/schemas/OpportunitySuggestedActionDetails'
            - type: 'null'
        justification:
          type: string
      required:
        - action
        - details
        - justification
      title: OpportunitySuggestedAction
    OpportunityValuePeriod:
      type: string
      enum:
        - one_time
        - monthly
        - annual
      title: OpportunityValuePeriod
    Opportunity:
      type: object
      properties:
        annualized_expected_value:
          type:
            - integer
            - 'null'
        annualized_value:
          type:
            - integer
            - 'null'
        attachments:
          type: array
          items:
            $ref: '#/components/schemas/Attachment'
        comment_summary:
          oneOf:
            - $ref: '#/components/schemas/CommentSummary'
            - type: 'null'
        confidence:
          type: integer
        contact_id:
          type:
            - string
            - 'null'
        contact_name:
          type:
            - string
            - 'null'
        created_by:
          type:
            - string
            - 'null'
        created_by_name:
          type:
            - string
            - 'null'
        date_created:
          type: string
          format: date-time
        date_lost:
          type:
            - string
            - 'null'
          format: date-time
        date_updated:
          type: string
          format: date-time
        date_won:
          type:
            - string
            - 'null'
          format: date
        expected_value:
          type:
            - integer
            - 'null'
        id:
          type: string
        integration_links:
          type: array
          items:
            $ref: '#/components/schemas/RenderedIntegrationLink'
        is_stalled:
          type: boolean
        lead_id:
          type: string
        lead_name:
          type:
            - string
            - 'null'
        lead_primary_email:
          oneOf:
            - $ref: '#/components/schemas/ContactEmail'
            - type: 'null'
        lead_primary_phone:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ContactPhone'
        note:
          type:
            - string
            - 'null'
        organization_id:
          type: string
        pipeline_id:
          type:
            - string
            - 'null'
        pipeline_name:
          type:
            - string
            - 'null'
        stall_status:
          oneOf:
            - $ref: '#/components/schemas/StalledOpportunityActionItems'
            - type: 'null'
        status_display_name:
          type: string
        status_id:
          type: string
        status_label:
          type: string
        status_type:
          $ref: '#/components/schemas/OpportunityStatusType'
        suggested_action:
          oneOf:
            - $ref: '#/components/schemas/OpportunitySuggestedAction'
            - type: 'null'
        updated_by:
          type:
            - string
            - 'null'
        updated_by_name:
          type:
            - string
            - 'null'
        user_id:
          type: string
        user_name:
          type:
            - string
            - 'null'
        value:
          type:
            - integer
            - 'null'
        value_currency:
          type:
            - string
            - 'null'
        value_formatted:
          type:
            - string
            - 'null'
        value_period:
          $ref: '#/components/schemas/OpportunityValuePeriod'
      required:
        - annualized_expected_value
        - annualized_value
        - confidence
        - contact_id
        - created_by
        - date_created
        - date_lost
        - date_updated
        - date_won
        - expected_value
        - id
        - lead_id
        - note
        - organization_id
        - status_id
        - updated_by
        - user_id
        - value
        - value_period
      title: Opportunity
  securitySchemes:
    ApiKeyAuth:
      type: http
      scheme: basic
    OAuth2:
      type: http
      scheme: bearer

```